import { Renderer2D } from "./renderer";
import { TriangleRenderer } from "./triangle_renderer";

export class CanvasApp{
    readonly gl: WebGL2RenderingContext;
    renderer: Renderer2D;
    trenderer : TriangleRenderer;
    constructor(gl: WebGL2RenderingContext){
        this.gl = gl;
        this.renderer = new Renderer2D(gl);
        this.trenderer = new TriangleRenderer(gl);
    }
    intialize():boolean{
        this.renderer.prepare();
        this.trenderer.prepare(this.gl);
        return true;
    }
    startRun(){
        const current = new Date();
        this.loop();
        const delta = (new Date().getMilliseconds()) - current.getMilliseconds();
        const delay = (delta < 16) ? (16 - delta) : 1;
        setTimeout((()=>{
            this.startRun();
        }).bind(this),delay);
    }
    loop(){
        
    }
    startDraw(){
        this.drawScene();
    }
    drawScene(){
        this.gl.viewport(0,0,this.gl.canvas.width,this.gl.canvas.height);
        
        this.gl.clearColor(0,0,0,0);
        this.gl.clear(this.gl.COLOR_BUFFER_BIT);
        this.renderer.draw(this.gl);
        this.trenderer.draw(this.gl);
        requestAnimationFrame(this.drawScene.bind(this));
    }
};